program Cgaemu;
{ StarFlight CGA Fix }

{$M $800,0,0 }   { 2K stack, no heap }
uses Crt, Dos;
var
  KbdIntVec : Procedure;
{$F+}
procedure KeyHit(Flags, PCS, PIP, PAX, PBX, PCX, PDX, PSI, PDI, PDS, PES, PBP: Word);
interrupt;
begin
  if (PAX shr 8) = $4f then
    { Throw it into an uncleared CGA mode when F12 pressed }
    begin
         if (PAX and $ff) = $58 then begin
            asm
               mov ax,85h
               int 10h
         end;
    end;
  end;
  KbdIntVec;
end;
{$F-}

begin
  Writeln('StarFlight CGA Mode Fix');
  Writeln('Press F12 to fix StarFlight''s CGA mode once loaded');
  GetIntVec($15,@KbdIntVec);
  SetIntVec($15,Addr(KeyHit));
  Keep(0);
end.
